var browser = browser || chrome;

browser.runtime.onMessage.addListener((message, sender, sendResponse) => {
	if (message.action == "lichess_doTranslate") {
		if (message.apikey) {
			let url = 'https://translate.yandex.net/api/v1.5/tr/translate';
			let body = 'key=' + message.apikey + '&lang=' + message.lang + '&options=1&format=plain&text=' + encodeURIComponent(message.text);
			let headers={
				'Content-Type': 'application/x-www-form-urlencoded'
			};
			fetch(url, {mode:'cors', method:'POST', headers:headers, body:body})
			.then(res => {
				res.text().then(text => {
					let ret = text.match(/\<Translation\s+code=\"200\"\s+lang=\"([^\"]+)\"\s*\>\s*\<detected\s+lang=\"[^\"]+\"\s*\/\>\s*\<text>\s*(.*)\s*\<\/text\>\s*\<\/Translation\>/);
					sendResponse({data:ret});
					return true;
				});
				return true;
			});
			return true;
		} else if(message.yaID) {
			let url = 'https://translate.yandex.net/api/v1/tr.json/translate';
			let body = 'id=' + message.yaID + '&srv=tr-text&lang=' + message.lang + '&reason=paste&text=' + encodeURIComponent(message.text);
			let headers={
				'Content-Type': 'application/x-www-form-urlencoded',
				'Host': 'translate.yandex.net',
				'User-Agent': navigator.userAgent,
				'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8',
				'Upgrade-Insecure-Requests' : '1',
				'Cache-Control': 'max-age=0',
				'Accept': '*/*',
				'Accept-Encoding': 'deflate, br',
				'Origin': 'https://translate.yandex.ru'
			};
			fetch(url, {mode:'cors', method:'POST', redirect:'manual', headers:headers, body:body})
			.then(res => {
				res.text().then(text => {
					let ret = text.match(/\{\s?\"code\"\s?:\s?200,\s?\"lang\"\s?:\s?\"(.*)\",\s?\"text\"\s?:\s?\[\s?\"(.*)\"\s?\]\s?\}/i);
					sendResponse({data:ret});
					return true;
				});
				return true;
			});
			return true;
		} else {
			let url = 'https://translate.yandex.ru/?lang=en';
			let headers={
				'Host': 'translate.yandex.ru',
				'User-Agent': navigator.userAgent,
				'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8',
				'Upgrade-Insecure-Requests' : '1',
				'Cache-Control': 'max-age=0',
				'Accept-Language': 'ru-RU,ru;q=0.8,en-US;q=0.6,en;q=0.4',
				'Accept-Encoding': 'deflate, br'
			};
			//fetch(url, {mode:'cors', method:'GET', redirect:'manual', headers:headers})
			fetch(url, {mode:'cors', method:'GET', redirect:'follow', credentials:'include', headers:headers})
			.then(res => {
                let redirected = res.redirected;
                let redirectedurl = res.url;
				res.text().then(text => {
					let ret = text.match(/\ssid: \'(.*)\'/i);
					sendResponse({data:ret, redirected:redirected, redirectedurl:redirectedurl});
					return true;
				});
				return true;
			});
			return true;
		}
	}
});

browser.runtime.onInstalled.addListener(function(){browser.runtime.openOptionsPage()});
