/**
 PhazaSoft littletools 
 Lichess chat Yandex translator by Phazeus (aka LamLamer)
 For free only!
**/

//Применение Mutation Events является устаревшим. Вместо них используйте MutationObserver.

const langs = {
	'en':'English',
	'ru':'Russian',
	'af':'Afrikaans',
	'am':'Amharic',
	'ar':'Arabic',
	'az':'Azerbaijan',
	'ba':'Bashkir',
	'be':'Belarusian',
	'bg':'Bulgarian',
	'bn':'Bengali',
	'bs':'Bosnian',
	'ca':'Catalan',
	'ceb':'Cebuano',
	'cs':'Czech',
	'cy':'Welsh',
	'da':'Danish',
	'de':'German',
	'el':'Greek',
	'eo':'Esperanto',
	'es':'Spanish',
	'et':'Estonian',
	'eu':'Basque',
	'fa':'Persian',
	'fi':'Finnish',
	'fr':'French',
	'ga':'Irish',
	'gd':'Scottish',
	'gl':'Galician',
	'gu':'Gujarati',
	'he':'Hebrew',
	'hi':'Hindi',
	'hr':'Croatian',
	'ht':'Haitian (Creole)',
	'hu':'Hungarian',
	'hy':'Armenian',
	'id':'Indonesian',
	'is':'Icelandic',
	'it':'Italian',
	'ja':'Japanese',
	'jv':'Javanese',
	'ka':'Georgian',
	'kk':'Kazakh',
	'km':'Khmer',
	'kn':'Kannada',
	'ko':'Korean',
	'ky':'Kyrgyz',
	'la':'Latin',
	'lb':'Luxembourgish',
	'lo':'Laotian',
	'lt':'Lithuanian',
	'lv':'Latvian',
	'mg':'Malagasy',
	'mhr':'Mari',
	'mi':'Maori',
	'mk':'Macedonian',
	'ml':'Malayalam',
	'mn':'Mongolian',
	'mr':'Marathi',
	'mrj':'Hill Mari',
	'ms':'Malay',
	'mt':'Maltese',
	'my':'Burmese',
	'ne':'Nepali',
	'nl':'Dutch',
	'no':'Norwegian',
	'pa':'Punjabi',
	'pap':'Papiamento',
	'pl':'Polish',
	'pt':'Portuguese',
	'ro':'Romanian',
	'si':'Sinhala',
	'sk':'Slovakian',
	'sl':'Slovenian',
	'sq':'Albanian',
	'sr':'Serbian',
	'su':'Sundanese',
	'sv':'Swedish',
	'sw':'Swahili',
	'ta':'Tamil',
	'te':'Telugu',
	'tg':'Tajik',
	'th':'Thai',
	'tl':'Tagalog',
	'tt':'Tatar',
	'tr':'Turkish',
	'udm':'Udmurt',
	'uk':'Ukrainian',
	'ur':'Urdu',
	'uz':'Uzbek',
	'vi':'Vietnamese',
	'xh':'Xhosa',
	'yi':'Yiddish',
	'zh':'Chinese',
};


var browser = browser || chrome;
var yaID = ''; //using if no Yandex API Key specified
var apikey = '';
var lang = 'en';
var langfrom = 'auto';
var mylangto = 'en';

var toTranslateQueue = [];
var translatedBuffer = '';


function get_yaID(sid) {
	let [s1, s2, s3] = sid.split('.');
	sid = s1.split('').reverse().join('') + '.' + s2.split('').reverse().join('') + '.' + s3.split('').reverse().join('');
	sid += '-1-0';
	return sid;
}


function doMyButtonClick(e) {
	let ts = e.target.ownerDocument.querySelector('.mchat__translate_select');
	if (!ts) return;
	mylangto = ts.value;
	browser.storage.local.set({
		['langto']: mylangto
	});
	let tb = e.target.ownerDocument.querySelector('.mchat__say');
	if (tb) {
		let text = tb.value.trim().replace(/\s+/g," ");
		if (!text) return;
		if (tb.value.length == 0) return;
		if (apikey) {
			browser.runtime.sendMessage({action:'lichess_doTranslate', apikey:apikey, lang:ts.value, text:text},
			function(res) {
				tb.value = res.data[2];
				tb.focus();
			});
		} else {
			if (!yaID) {
				browser.runtime.sendMessage({action:'lichess_doTranslate', lang:ts.value},
				function(res) {
					if (res.data) {
						yaID=get_yaID(res.data[1]);
						e.target.ownerDocument.querySelector('.mchat__translate_to').click();
						return;
					} else if (res.redirected && res.redirectedurl) {
                        tb.value = '[ERROR] ' + res.redirectedurl;
                        return;
					}
				});
				/*
				let origUrl = 'https://translate.yandex.ru/?lang=en';
				let xhr = new XMLHttpRequest;
				xhr.onload = function() {
					if (this.responseURL != origUrl) {
						tb.value = '[ERROR] ' + this.responseURL;
						return;
					} else {
						let res = this.responseText;
						if (res) {
							let ret = res.match(/\ssid: \'(.*)\'/i);
							if (ret) {
								yaID=get_yaID(ret[1]);
								e.target.ownerDocument.querySelector('.mchat__translate_to').click();
								return;
							}
						}
					}
				}
				xhr.open('GET', origUrl, true);
				xhr.overrideMimeType('text/html; charset=UTF-8');
				xhr.withCredentials = true;
				xhr.timeout = 5000;
				xhr.send();
				*/
			} else {
				browser.runtime.sendMessage({action:'lichess_doTranslate', yaID:yaID, lang:ts.value, text:text},
				function(res) {
					tb.value = res.data[2];
					tb.focus();
				});
			}
		}
	}
}

function doTranslate(e, isqueue) {
	if (toTranslateQueue.length > 0 && !isqueue) return;
	if (lang == langfrom) return;
	if (e.target) {
		e.target.removeAttribute('title');
		e.target.setAttribute('translated', true);
		let text = '';
		if (toTranslateQueue.length == 0 && (apikey || yaID)) {
			translatedBuffer = '';
			toTranslateQueue = [];
			for (i = 0; i < e.target.childNodes.length; i++) {
				if (e.target.childNodes[i].nodeType == 3) {
					text += ' ' + e.target.childNodes[i].nodeValue;
				}
			}
			text = text.trim().replace(/\s+/g," ");
			if (!text) return;
		}
		if (apikey) {
			e.target.removeEventListener('click', doTranslate);
			browser.runtime.sendMessage({action:'lichess_doTranslate', apikey:apikey, lang:((langfrom=='auto') ? '' : langfrom+'-')+lang, text:text},
			function(res) {
				e.target.innerHTML += ' [' + res.data[1] + '] ' + res.data[2];
			});
		} else {
			if (text) toTranslateQueue = text.split(/(\S[\.\?\!\)\;])\s+/); //{"code":413,"message":"The text size exceeds the maximum"}
			if (!yaID) {
				browser.runtime.sendMessage({action:'lichess_doTranslate', lang:((langfrom=='auto') ? '' : langfrom+'-')+lang},
				function(res) {
					if (res.data) {
						yaID=get_yaID(res.data[1]);
						e.target.click();
						return;
					} else if (res.redirected && res.redirectedurl) {
						e.target.removeEventListener('click', doTranslate);
                        e.target.innerHTML += ' [ERROR] ' + res.redirectedurl;
                        return;
					}
				});
				/*
				let origUrl = 'https://translate.yandex.ru/?lang=en';
				let xhr = new XMLHttpRequest;
				xhr.onload = function() {
					if (this.responseURL != origUrl) {
						e.target.removeEventListener('click', doTranslate);
						e.target.innerHTML += ' [ERROR] ' + this.responseURL;
						return;
					} else {
						let res = this.responseText;
						if (res) {
							let ret = res.match(/\ssid: \'(.*)\'/i);
							if (ret) {
								yaID=get_yaID(ret[1]);
								//e.target.click();
								doTranslate(e);
								return;
							}
						}
					}
				}
				xhr.open('GET', origUrl, true);
				xhr.overrideMimeType('text/html; charset=UTF-8');
				xhr.withCredentials = true;
				xhr.timeout = 5000;
				xhr.send();
				*/
			} else {
				e.target.removeEventListener('click', doTranslate);
				let totrans = '';
				while (toTranslateQueue.length > 0) {
					totrans += toTranslateQueue[0] + (toTranslateQueue[1] ? toTranslateQueue[1] : '') + ' ';
					toTranslateQueue.splice(0,2);
					if (totrans.length > 500 || totrans.length + (toTranslateQueue[0] ? toTranslateQueue[0].length : 0) + (toTranslateQueue[1] ? toTranslateQueue[1].length : 0) > 500) break;
				}
				browser.runtime.sendMessage({action:'lichess_doTranslate', yaID:yaID, lang:((langfrom=='auto') ? '' : langfrom+'-')+lang, text:totrans},
				function(res) {
					translatedBuffer += res.data[2] + ' ';
					if (toTranslateQueue.length > 0) {
						doTranslate(e, true);
						return;
					} else {
						e.target.innerHTML += ' [' + res.data[1] + '] ' + translatedBuffer.trim();
						translatedBuffer = '';
					}
				});
			}
		}
	}
}


function translate_post(e, isqueue) {
	if (toTranslateQueue.length > 0 && !isqueue) return;
	if (lang == langfrom) return;
	if (e.target) {
		let t = e.target.parentNode.parentNode.parentNode.querySelector('p.forum-post__message');
		if (!t) t = e.target.parentNode.parentNode.parentNode.querySelector('div.message-thread__message__body');
		let s = '';
		if (toTranslateQueue.length == 0 && (apikey || yaID)) {
			translatedBuffer = '';
			toTranslateQueue = [];
			for (i = 0; i < t.childNodes.length; i++) {
				if (t.childNodes[i].nodeType == 3) {
					s += ' ' + t.childNodes[i].nodeValue;
				}
			}
			s = s.trim().replace(/\s+/g," ");
			if (!s) return;
		}
		if (apikey) {
			browser.runtime.sendMessage({action:'lichess_doTranslate', apikey:apikey, lang:((langfrom=='auto') ? '' : langfrom+'-')+lang, text:s},
			function(res) {
				t.innerHTML += '<br>[' + res.data[1] + ']<br>' + res.data[2];
			});
			e.target.remove();
		} else {
			if (s) toTranslateQueue = s.split(/(\S[\.\?\!\)\;])\s+/); //{"code":413,"message":"The text size exceeds the maximum"}
			if (!yaID) {
				browser.runtime.sendMessage({action:'lichess_doTranslate', lang:((langfrom=='auto') ? '' : langfrom+'-')+lang},
				function(res) {
					if (res.data) {
						yaID=get_yaID(res.data[1]);
						e.target.click();
						return;
					} else if (res.redirected && res.redirectedurl) {
						e.target.remove();
                        t.innerHTML += '<br>[ERROR]<br><a href="' + res.redirectedurl + '">' + res.redirectedurl + '</a>';
                        return;
					}
				});
				/*
				let origUrl = 'https://translate.yandex.ru/?lang=en';
				let xhr = new XMLHttpRequest;
				xhr.onload = function() {
					if (this.responseURL != origUrl) {
						e.target.remove();
						t.innerHTML += '<br>[ERROR]<br><a href="' + this.responseURL + '">' + this.responseURL + '</a>';
						return;
					} else {
						let res = this.responseText;
						if (res) {
							let ret = res.match(/\ssid: \'(.*)\'/i);
							if (ret) {
								yaID=get_yaID(ret[1]);
								e.target.click();
								return;
							}
						}
					}
				}
				xhr.open('GET', origUrl, true);
				xhr.overrideMimeType('text/html; charset=UTF-8');
				xhr.withCredentials = true;
				xhr.timeout = 5000;
				xhr.send();
				*/
			} else {
				let totrans = '';
				while (toTranslateQueue.length > 0) {
					totrans += toTranslateQueue[0] + (toTranslateQueue[1] ? toTranslateQueue[1] : '') + ' ';
					toTranslateQueue.splice(0,2);
					if (totrans.length > 500 || totrans.length + (toTranslateQueue[0] ? toTranslateQueue[0].length : 0) + (toTranslateQueue[1] ? toTranslateQueue[1].length : 0) > 500) break;
				}
				browser.runtime.sendMessage({action:'lichess_doTranslate', yaID:yaID, lang:((langfrom=='auto') ? '' : langfrom+'-')+lang, text:totrans.trim()},
				function(res) {
					translatedBuffer += res.data[2] + ' ';
					if (toTranslateQueue.length > 0) {
						translate_post(e, true);
						return;
					} else {
						e.target.remove();
						t.innerHTML += '<br>[' + res.data[1] + ']<br>' + translatedBuffer.trim();
						translatedBuffer = '';
					}
				});
			}
		}
	}
}

function translate_my_post(e, isqueue) {
	if (toTranslateQueue.length > 0 && !isqueue) return;
	let ts = e.target.ownerDocument.querySelector('.post_translate_select');
	if (!ts) return;
	mylangto = ts.value;
	browser.storage.local.set({
		['langto']: mylangto
	});
	let tb = e.target.ownerDocument.querySelector('textarea#form3-text.form-control.post-text-area');
	if (!tb) tb = e.target.ownerDocument.querySelector('textarea.form-control');
	if (!tb) tb = e.target.ownerDocument.querySelector('textarea.msg-app__convo__post__text');
	if (tb) {
		if (tb.value.length == 0) return;
		let s = '';
		if (toTranslateQueue.length == 0 && (apikey || yaID)) {
			translatedBuffer = '';
			toTranslateQueue = [];
			s = tb.value.trim().replace(/\s+/g," ");
			if (!s) return;
		}
		if (apikey) {
			browser.runtime.sendMessage({action:'lichess_doTranslate', apikey:apikey, lang:ts.value, text:s},
			function(res) {
				tb.value = res.data[2];
				tb.focus();
			});
		} else {
			if (s) toTranslateQueue = s.split(/(\S[\.\?\!\)\;])\s+/); //{"code":413,"message":"The text size exceeds the maximum"}
			if (!yaID) {
				browser.runtime.sendMessage({action:'lichess_doTranslate', lang:ts.value},
				function(res) {
					if (res.data) {
						yaID=get_yaID(res.data[1]);
						e.target.ownerDocument.querySelector('.translate_my_post').click();
						return;
					} else if (res.redirected && res.redirectedurl) {
                        tb.value += ' [ERROR] ' + res.redirectedurl;
                        return;
					}
				});
				/*
				let origUrl = 'https://translate.yandex.ru/?lang=en';
				let xhr = new XMLHttpRequest;
				xhr.onload = function() {
					if (this.responseURL != origUrl) {
						tb.value += ' [ERROR] ' + res.redirectedurl;
						return;
					} else {
						let res = this.responseText;
						if (res) {
							let ret = res.match(/\ssid: \'(.*)\'/i);
							if (ret) {
								yaID=get_yaID(ret[1]);
								e.target.ownerDocument.querySelector('.translate_my_post').click();
								return;
							}
						}
					}
				}
				xhr.open('GET', origUrl, true);
				xhr.overrideMimeType('text/html; charset=UTF-8');
				xhr.withCredentials = true;
				xhr.timeout = 5000;
				xhr.send();
				*/
			} else {
				let totrans = '';
				while (toTranslateQueue.length > 0) {
					totrans += toTranslateQueue[0] + (toTranslateQueue[1] ? toTranslateQueue[1] : '') + ' ';
					toTranslateQueue.splice(0,2);
					if (totrans.length > 500 || totrans.length + (toTranslateQueue[0] ? toTranslateQueue[0].length : 0) + (toTranslateQueue[1] ? toTranslateQueue[1].length : 0) > 500) break;
				}
				browser.runtime.sendMessage({action:'lichess_doTranslate', yaID:yaID, lang:ts.value, text:totrans},
				function(res) {
					translatedBuffer += res.data[2] + ' ';
					if (toTranslateQueue.length > 0) {
						translate_my_post(e, true);
						return;
					} else {
						tb.value = translatedBuffer.trim();
						translatedBuffer = '';
						tb.focus();
					}
				});
			}
		}
	}
}



function inspect_chat(mchat) {
	if (!mchat.getAttribute('readytotranslate')) {
		mchat.setAttribute('readytotranslate', true);
		let tNodes = mchat.querySelectorAll('t');
		for (i = 0; i < tNodes.length; i++) {
			if (!tNodes[i].getAttribute('translated')) {
				tNodes[i].setAttribute('title', (browser.i18n.getMessage('Translate_to') || 'Translate to') + ' [' + lang + ']...');
				tNodes[i].addEventListener('click', doTranslate);
			}
		}
		mchat.addEventListener('DOMNodeInserted', modifyObj, false);
		mchat.addEventListener('DOMNodeRemoved', function(e) {
				e.relatedNode.addEventListener('DOMSubtreeModified', makeReady, false);
		}, false);
		let chattab = mchat.ownerDocument.querySelector('.mchat__tabs');
		if (chattab) {
			if (chattab.querySelector('.mchat__translate_to')) return;
			let tb = mchat.ownerDocument.createElement('BUTTON');
			tb.setAttribute('class', 'mchat__translate_to');
			tb.setAttribute('title', browser.i18n.getMessage('Translate_my_message') || 'Translate my message');
			tb.setAttribute('style', 'padding:0px;border:0;border-radius:0px;background:none;-webkit-appearance:none;color:red;font-weight:bold;');
			tb.innerHTML='<\u042f';
			tb.addEventListener('click', doMyButtonClick, false);
			let sl = mchat.ownerDocument.createElement('SELECT');
			sl.setAttribute('class', 'mchat__translate_select');
			sl.setAttribute('title', browser.i18n.getMessage('Translate_my_messages_to') || 'Translate my messages to...');
			sl.setAttribute('style', 'overflow:hidden;padding:0px;appearance:none;-moz-appearance:none;-webkit-appearance:none;background:transparent;box-shadow:none;border:none;display:block;outline:none;');
			for (var i in langs) {
				let op = mchat.ownerDocument.createElement('OPTION');
				op.innerHTML = i;
				op.setAttribute('title',langs[i]);
				op.setAttribute('value', i);
				if (i == mylangto) op.setAttribute('selected', true);
				sl.appendChild(op);
			}
			chattab.appendChild(sl);
			chattab.appendChild(tb);
		}
	}
}

function makeReady(e) {
	if (!e.target.querySelector) return;
	let mchat = e.target.querySelector('.mchat__messages');
	if (mchat) {
		inspect_chat(mchat);
		mchat.ownerDocument.documentElement.removeEventListener('DOMSubtreeModified', makeReady, false);
		e.target.removeEventListener('DOMSubtreeModified', makeReady, false);
	}
}

function makeReadyPrivate(e) {
	if (!e.target.querySelector || !e.target.matches || !e.target.matches('group')) return;
	let els = e.target.querySelectorAll('group their t');
	for (let i of els) {
		if (!i.getAttribute('readytotranslate') && !i.getAttribute('translated')) {
			i.setAttribute('readytotranslate', true);
			i.setAttribute('title', (browser.i18n.getMessage('Translate_to') || 'Translate to') + ' [' + lang + ']...');
			i.addEventListener('click', doTranslate);
		}
	}
}

function modifyObj(e) {
	if (!e.target.querySelector) return;
	let message_t = e.target.querySelector('t');
	if (message_t) {
		message_t.setAttribute('title', (browser.i18n.getMessage('Translate_to') || 'Translate to') + ' [' + lang + ']...');
		message_t.addEventListener('click', doTranslate);
	}
}

function div_comment_div_content_mod(e) {
	if (e && e.target) {
		e.target.setAttribute('readytotranslate', true);
		e.target.removeAttribute('translated');
		e.target.setAttribute('title', (browser.i18n.getMessage('Translate_to') || 'Translate to') + ' [' + lang + ']...');
		e.target.addEventListener('click', div_comment_div_content_cl);
	}
}
function div_comment_div_content_mod2(e) {
	e.target.removeEventListener('DOMSubtreeModified', div_comment_div_content_mod2, false);
	e.target.addEventListener('DOMSubtreeModified', div_comment_div_content_mod, false);
}
function div_comment_div_content_cl(e) {
	e.target.removeEventListener('DOMSubtreeModified', div_comment_div_content_mod, false);
	e.target.removeEventListener('click', div_comment_div_content_cl);
	doTranslate(e);
	e.target.addEventListener('DOMSubtreeModified', div_comment_div_content_mod2, false);
}

function MainAnalyseCook(e, el) {
	if (e && e.target && e.target.matches
	    && (e.target.matches('div.analyse__tools') || e.target.matches('div.gamebook')
	        || e.target.matches('div.analyse__underboard')
	        || e.target.matches('div.comment')
	        || e.target.matches('div.msg-app__convo'))) {
		let p = e.target.parentNode;
		setTimeout(function() {if (p) MainAnalyseCook(false, p)}, 3000);
		return;
	} else if (el) {
		let els = el.querySelector('div.analyse__tools');
		if (els) els.addEventListener('DOMNodeRemoved', MainAnalyseCook, false);
		els = el.querySelectorAll('interrupt comment');
		if (els.length) {
			for (let i of els) {
				if (!i.getAttribute('readytotranslate') && !i.getAttribute('translated')) {
					i.setAttribute('readytotranslate', true);
					i.setAttribute('title', (browser.i18n.getMessage('Translate_to') || 'Translate to') + ' [' + lang + ']...');
					i.addEventListener('click', doTranslate);
				}
			}
		}
		els = el.querySelector('div.gamebook');
		if (els) els.addEventListener('DOMNodeRemoved', MainAnalyseCook, false);
		els = el.querySelectorAll('div.comment div.content');
		if (els.length) {
			for (let i of els) {
				if (!i.getAttribute('readytotranslate') && !i.getAttribute('translated')) {
					i.setAttribute('readytotranslate', true);
					i.setAttribute('title', (browser.i18n.getMessage('Translate_to') || 'Translate to') + ' [' + lang + ']...');
					i.addEventListener('click', div_comment_div_content_cl);
					i.addEventListener('DOMSubtreeModified', div_comment_div_content_mod, false);
					i.parentNode.addEventListener('DOMNodeRemoved', MainAnalyseCook, false);
				}
			}
		}
		els = el.querySelector('div.analyse__underboard');
		if (els) els.addEventListener('DOMNodeRemoved', MainAnalyseCook, false);
		els = el.querySelectorAll('div.feedback div.comment');
		if (els.length) {
			for (let i of els) {
				if (!i.getAttribute('readytotranslate') && !i.getAttribute('translated')) {
					i.setAttribute('readytotranslate', true);
					i.setAttribute('title', (browser.i18n.getMessage('Translate_to') || 'Translate to') + ' [' + lang + ']...');
					i.addEventListener('click', doTranslate);
				}
			}
		}
		els = el.querySelectorAll('div.study-desc div.text');
		if (els.length) {
			for (let i of els) {
				if (!i.getAttribute('readytotranslate') && !i.getAttribute('translated')) {
					i.setAttribute('readytotranslate', true);
					i.setAttribute('title', (browser.i18n.getMessage('Translate_to') || 'Translate to') + ' [' + lang + ']...');
					i.addEventListener('click', doTranslate);
				}
			}
		}
		
		els = el.querySelectorAll('group their t');
		if (els.length) {
			for (let i of els) {
				if (!i.getAttribute('readytotranslate') && !i.getAttribute('translated')) {
					i.setAttribute('readytotranslate', true);
					i.setAttribute('title', (browser.i18n.getMessage('Translate_to') || 'Translate to') + ' [' + lang + ']...');
					i.addEventListener('click', doTranslate);
				}
			}
		}
		els = el.querySelector('textarea.msg-app__convo__post__text');
		if (els) {
			if (!els.parentNode.getAttribute('readytotranslate')) {
				els.parentNode.setAttribute('readytotranslate', true);
				let tb = el.ownerDocument.createElement('BUTTON');
				tb.setAttribute('type', 'button');
				tb.setAttribute('class', 'translate_my_post');
				tb.setAttribute('title', browser.i18n.getMessage('Translate_my_message') || 'Translate my message');
				tb.setAttribute('style', 'padding:0 0 0 2px;border:0;border-radius:0px;background:none;-webkit-appearance:none;color:red;font-weight:bold;display:block;');
				tb.innerHTML='<\u042f';
				tb.addEventListener('click', translate_my_post, false);
				let sl = el.ownerDocument.createElement('SELECT');
				sl.setAttribute('class', 'post_translate_select');
				sl.setAttribute('title', browser.i18n.getMessage('Translate_my_messages_to') || 'Translate my messages to...');
				sl.setAttribute('style', 'overflow:hidden;padding:0 0 0 2px;appearance:none;-moz-appearance:none;-webkit-appearance:none;background:transparent;box-shadow:none;border:none;display:block;outline:none;');
				for (var i in langs) {
					let op = el.ownerDocument.createElement('OPTION');
					op.innerHTML = i;
					op.setAttribute('title', langs[i]);
					op.setAttribute('value', i);
					if (i == mylangto) op.setAttribute('selected', true);
					sl.appendChild(op);
				}
				let dd = el.ownerDocument.createElement('DIV');
				dd.appendChild(sl);
				dd.appendChild(tb);
				els.parentNode.parentNode.appendChild(dd);
			}
		}
		els = el.querySelector('div.msg-app__convo__msgs__content');
		if (els) {
			els.removeEventListener('DOMNodeInserted', makeReadyPrivate, false);
			els.addEventListener('DOMNodeInserted', makeReadyPrivate, false);
		}
	}
}

function addDiv(theDoc) {
	let mchat = theDoc.querySelector('div.analyse__tools');
	if (mchat) {
		mchat.addEventListener('DOMNodeRemoved', MainAnalyseCook, false);
		MainAnalyseCook(false, mchat.parentNode);
	}
	mchat = theDoc.querySelector('div.gamebook');
	if (mchat) {
		mchat.addEventListener('DOMNodeRemoved', MainAnalyseCook, false);
		MainAnalyseCook(false, mchat.parentNode);
	}
	mchat = theDoc.querySelector('div.analyse__underboard');
	if (mchat) {
		mchat.addEventListener('DOMNodeRemoved', MainAnalyseCook, false);
		MainAnalyseCook(false, mchat.parentNode);
	}
	
	mchat = theDoc.querySelector('main.msg-app');
	if (mchat) {
		mchat.addEventListener('DOMNodeRemoved', MainAnalyseCook, false);
		MainAnalyseCook(false, mchat.parentNode);
	}
	mchat = theDoc.querySelector('div.msg-app__convo__msgs__content');
	if (mchat) {
		mchat.removeEventListener('DOMNodeInserted', makeReadyPrivate, false);
		mchat.addEventListener('DOMNodeInserted', makeReadyPrivate, false);
	}
	
	mchat = theDoc.querySelector('.mchat__messages');
	if (mchat) {
		inspect_chat(mchat);
		return;
	}
	mchat = theDoc.querySelector('.mchat__content');
	if (mchat) {
		theDoc.documentElement.addEventListener('DOMSubtreeModified', makeReady, false);
		mchat.addEventListener('DOMSubtreeModified', makeReady, false);
		return;
	}
	
	let private_thread = false;
	mchat = theDoc.querySelectorAll('article.forum-post');
	if (!mchat.length) {
		private_thread = true;
		mchat = theDoc.querySelectorAll('article.message-thread__message');
	}
	if (mchat.length > 0) {
		for (i = 0; i < mchat.length; i++) {
			if (!mchat[i].getAttribute('readytotranslate')) {
				mchat[i].setAttribute('readytotranslate', true);
				let tb = theDoc.createElement('BUTTON');
				tb.setAttribute('class', 'post_translate_to');
				tb.setAttribute('title', (browser.i18n.getMessage('Translate_to') || 'Translate to') + ' [' + lang + ']...');
				tb.setAttribute('style', 'padding:0 10px 0 10px;border:0;border-radius:0px;background:none;-webkit-appearance:none;color:red;font-weight:bold;');
				tb.innerHTML='[\u042f]';
				tb.addEventListener('click', translate_post, false);
				let p = null;
				if (private_thread) p = mchat[i].querySelector('div.infos > div');
				else p = mchat[i].querySelector('.forum-post__metas > div');
				if (p) p.appendChild(tb);
			}
		}
	}
	
	private_thread = false;
	mchat = theDoc.querySelector('div.form-group > textarea');
	//if (!mchat) {
	//	private_thread = true;
	//	mchat = theDoc.querySelector('div.message-thread__answer > form > div > textarea');
	//}
	if (!mchat) {
		private_thread = true;
		mchat = theDoc.querySelector('textarea.msg-app__convo__post__text');
	}
	if (mchat) {
		if (!mchat.parentNode.getAttribute('readytotranslate')) {
			mchat.parentNode.setAttribute('readytotranslate', true);
			let tb = theDoc.createElement('BUTTON');
			tb.setAttribute('type', 'button');
			tb.setAttribute('class', 'translate_my_post');
			tb.setAttribute('title', browser.i18n.getMessage('Translate_my_message') || 'Translate my message');
			if (private_thread) {
				tb.setAttribute('style', 'padding:0 0 0 2px;border:0;border-radius:0px;background:none;-webkit-appearance:none;color:red;font-weight:bold;display:block;');
			} else {
				tb.setAttribute('style', 'padding:0 1px 3px 1px;border:0;border-radius:0px;background:none;-webkit-appearance:none;color:red;font-weight:bold;display:inline-block;');
			}
			tb.innerHTML='<\u042f';
			tb.addEventListener('click', translate_my_post, false);
			let sl = theDoc.createElement('SELECT');
			sl.setAttribute('class', 'post_translate_select');
			sl.setAttribute('title', browser.i18n.getMessage('Translate_my_messages_to') || 'Translate my messages to...');
			if (private_thread) {
				sl.setAttribute('style', 'overflow:hidden;padding:0 0 0 2px;appearance:none;-moz-appearance:none;-webkit-appearance:none;background:transparent;box-shadow:none;border:none;display:block;outline:none;');
			} else {
				sl.setAttribute('style', 'overflow:hidden;padding:0 1px 3px 1px;margin:1px;appearance:none;-moz-appearance:none;-webkit-appearance:none;background:transparent;box-shadow:none;border:none;display:inline-block;outline:none;');
			}
			for (var i in langs) {
				let op = theDoc.createElement('OPTION');
				op.innerHTML = i;
				op.setAttribute('title',langs[i]);
				op.setAttribute('value', i);
				if (i == mylangto) op.setAttribute('selected', true);
				sl.appendChild(op);
			}
			if (private_thread) {
				//mchat.parentNode.insertBefore(sl, mchat);
				//mchat.parentNode.insertBefore(tb, mchat);
				let dd = theDoc.createElement('DIV');
				dd.appendChild(sl);
				dd.appendChild(tb);
				mchat.parentNode.parentNode.appendChild(dd);
			} else {
				mchat.parentNode.appendChild(sl);
				mchat.parentNode.appendChild(tb);
			}
			
		}
	}
}

function readyDoc(e) {
	if (e && e.target && e.target.readyState && e.target.readyState === 'complete') {
		setTimeout(function() {if (e && e.target) addDiv(e.target)}, 3000);
	}
}

browser.storage.local.get('apikey', function (result) {
	apikey = result.apikey || '';
	browser.storage.local.get('lang', function (result) {
		lang = result.lang || 'en';
		browser.storage.local.get('langto', function (result) {
			mylangto = result.langto || 'en';
			browser.storage.local.get('langfrom', function (result) {
				langfrom = result.langfrom || 'auto';
				if (document.readyState === 'complete') {
					setTimeout(function() {if (document) addDiv(document)}, 3000);
				} else {
					document.addEventListener('readystatechange', readyDoc, false);
				}
			});
		});
	});
});
